function [Y1 N1 N2] = GetRandomPatches(I, winsize,npatches,downsample)

 [m1 n1 n2] = size(I);
  w = winsize;  
   N1 = randperm(m1-w+1);
   N2 = randperm(n1-w+1);

   while length(N1) < npatches
       a = randperm(m1-w+1);
       N1 = [N1 a];
   end
   while length(N2) < npatches
       a = randperm(n1-w+1);
       N2 = [N2 a];
   end

    Y1 = [];
    for i = 1:npatches
        I1 = I(N1(i):N1(i)+w-1,N2(i):N2(i)+w-1,:);
         if exist('downsample','var')
             I1 = imresize(I1,downsample);
         end
        Y1 = [Y1 I1(:)];
    end
    
end